diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/test/wifi-gcr-test.cc ns-3.46/src/wifi/test/wifi-gcr-test.cc
--- ns-3.45/src/wifi/test/wifi-gcr-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/test/wifi-gcr-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -1806,7 +1806,7 @@
          std::vector<std::pair<bool, std::string>>{{false, "A-MPDU disabled"},
                                                    {true, "A-MPDU enabled"}})
     {
-        for (auto& [rtsThreshold, gcrPotection, protectionName] :
+        for (auto& [rtsThreshold, gcrProtection, protectionName] :
              std::vector<std::tuple<uint32_t, GroupcastProtectionMode, std::string>>{
                  {maxRtsCtsThreshold, GroupcastProtectionMode::RTS_CTS, "no protection"},
                  {500, GroupcastProtectionMode::RTS_CTS, "RTS-CTS"},
@@ -1850,7 +1850,7 @@
                                    .numGroupcastPackets = useAmpdu ? uint16_t(4) : uint16_t(2),
                                    .maxNumMpdusInPsdu = useAmpdu ? uint16_t(2) : uint16_t(1),
                                    .rtsThreshold = rtsThreshold,
-                                   .gcrProtectionMode = gcrPotection},
+                                   .gcrProtectionMode = gcrProtection},
                                   {}),
                     useSpectrum ? TestCase::Duration::EXTENSIVE : TestCase::Duration::QUICK);
                 AddTestCase(
@@ -1859,7 +1859,7 @@
                                    .numGroupcastPackets = useAmpdu ? uint16_t(4) : uint16_t(2),
                                    .maxNumMpdusInPsdu = useAmpdu ? uint16_t(2) : uint16_t(1),
                                    .rtsThreshold = rtsThreshold,
-                                   .gcrProtectionMode = gcrPotection,
+                                   .gcrProtectionMode = gcrProtection,
                                    // if no MPDU aggregation, MPDUs list is ignored
                                    .mpdusToCorruptPerPsdu = {{1, {{0, {1, 2}}}}}},
                                   {}),
@@ -1870,7 +1870,7 @@
                                    .numGroupcastPackets = useAmpdu ? uint16_t(4) : uint16_t(2),
                                    .maxNumMpdusInPsdu = useAmpdu ? uint16_t(2) : uint16_t(1),
                                    .rtsThreshold = rtsThreshold,
-                                   .gcrProtectionMode = gcrPotection,
+                                   .gcrProtectionMode = gcrProtection,
                                    // if no MPDU aggregation, MPDUs list is ignored
                                    .mpdusToCorruptPerPsdu = {{1, {{0, {1, 2}}}},
                                                              {2, {{0, {1, 2}}}},
@@ -1887,7 +1887,7 @@
                                    .numGroupcastPackets = useAmpdu ? uint16_t(4) : uint16_t(2),
                                    .maxNumMpdusInPsdu = useAmpdu ? uint16_t(2) : uint16_t(1),
                                    .rtsThreshold = rtsThreshold,
-                                   .gcrProtectionMode = gcrPotection,
+                                   .gcrProtectionMode = gcrProtection,
                                    // if no MPDU aggregation, MPDUs list is ignored
                                    .mpdusToCorruptPerPsdu = {{1, {{0, {1, 2}}}},
                                                              {2, {{0, {1, 2}}}},
@@ -1909,7 +1909,7 @@
                                        .numGroupcastPackets = 4,
                                        .maxNumMpdusInPsdu = 2,
                                        .rtsThreshold = rtsThreshold,
-                                       .gcrProtectionMode = gcrPotection,
+                                       .gcrProtectionMode = gcrProtection,
                                        .mpdusToCorruptPerPsdu = {{1, {{0, {2}}}},
                                                                  {2, {{0, {1}}}},
                                                                  {3, {{0, {2}}}},
@@ -1928,7 +1928,7 @@
                                        .numGroupcastPackets = 4,
                                        .maxNumMpdusInPsdu = 2,
                                        .rtsThreshold = rtsThreshold,
-                                       .gcrProtectionMode = gcrPotection,
+                                       .gcrProtectionMode = gcrProtection,
                                        .mpdusToCorruptPerPsdu = {{1, {{0, {1}}}},
                                                                  {2, {{0, {2}}}},
                                                                  {3, {{0, {1}}}},
@@ -1947,7 +1947,7 @@
                                        .numGroupcastPackets = 4,
                                        .maxNumMpdusInPsdu = 2,
                                        .rtsThreshold = rtsThreshold,
-                                       .gcrProtectionMode = gcrPotection,
+                                       .gcrProtectionMode = gcrProtection,
                                        .mpdusToCorruptPerPsdu = {{1, {{0, {1, 2}}}},
                                                                  {2, {{0, {1, 2}}}},
                                                                  {3, {{0, {1, 2}}}},
@@ -1966,7 +1966,7 @@
                                        .numGroupcastPackets = 4,
                                        .maxNumMpdusInPsdu = 2,
                                        .rtsThreshold = rtsThreshold,
-                                       .gcrProtectionMode = gcrPotection,
+                                       .gcrProtectionMode = gcrProtection,
                                        .mpdusToCorruptPerPsdu = {{1, {{0, {1, 2}}}},
                                                                  {2, {{0, {1, 2}}}},
                                                                  {3, {{0, {1, 2}}}},
@@ -1984,7 +1984,7 @@
                                        .numGroupcastPackets = 4,
                                        .maxNumMpdusInPsdu = 2,
                                        .rtsThreshold = rtsThreshold,
-                                       .gcrProtectionMode = gcrPotection,
+                                       .gcrProtectionMode = gcrProtection,
                                        .mpdusToCorruptPerPsdu = {{1, {{0, {1, 2}}}},
                                                                  {2, {{0, {1, 2}}}},
                                                                  {3, {{0, {1, 2}}}},
@@ -2003,7 +2003,7 @@
                                      .numGroupcastPackets = 4,
                                      .maxNumMpdusInPsdu = 2,
                                      .rtsThreshold = rtsThreshold,
-                                     .gcrProtectionMode = gcrPotection,
+                                     .gcrProtectionMode = gcrProtection,
                                      .mpdusToCorruptPerPsdu = {{9, {{0, {2}}}},
                                                                {10, {{0, {1}}}},
                                                                {11, {{0, {2}}}},
@@ -2023,7 +2023,7 @@
                                      .numGroupcastPackets = 4,
                                      .maxNumMpdusInPsdu = 2,
                                      .rtsThreshold = rtsThreshold,
-                                     .gcrProtectionMode = gcrPotection,
+                                     .gcrProtectionMode = gcrProtection,
                                      .mpdusToCorruptPerPsdu = {{9, {{0, {1}}}},
                                                                {10, {{0, {2}}}},
                                                                {11, {{0, {1}}}},
@@ -2043,7 +2043,7 @@
                                        .numGroupcastPackets = 4,
                                        .maxNumMpdusInPsdu = 2,
                                        .rtsThreshold = rtsThreshold,
-                                       .gcrProtectionMode = gcrPotection,
+                                       .gcrProtectionMode = gcrProtection,
                                        .mpdusToCorruptPerPsdu = {{9, {{0, {1, 2}}}},
                                                                  {10, {{0, {1, 2}}}},
                                                                  {11, {{0, {1, 2}}}},
@@ -2062,7 +2062,7 @@
                                        .numGroupcastPackets = 4,
                                        .maxNumMpdusInPsdu = 2,
                                        .rtsThreshold = rtsThreshold,
-                                       .gcrProtectionMode = gcrPotection,
+                                       .gcrProtectionMode = gcrProtection,
                                        .mpdusToCorruptPerPsdu = {{9, {{0, {1, 2}}}},
                                                                  {10, {{0, {1, 2}}}},
                                                                  {11, {{0, {1, 2}}}},
@@ -2080,7 +2080,7 @@
                                        .numGroupcastPackets = 4,
                                        .maxNumMpdusInPsdu = 2,
                                        .rtsThreshold = rtsThreshold,
-                                       .gcrProtectionMode = gcrPotection,
+                                       .gcrProtectionMode = gcrProtection,
                                        .mpdusToCorruptPerPsdu = {{9, {{0, {1, 2}}}},
                                                                  {10, {{0, {1, 2}}}},
                                                                  {11, {{0, {1, 2}}}},
@@ -2200,7 +2200,7 @@
                                                                           {{}, {1}},
                                                                           {{1}, {1}}})
         {
-            for (auto& [rtsThreshold, gcrPotection, protectionName] :
+            for (auto& [rtsThreshold, gcrProtection, protectionName] :
                  std::vector<std::tuple<uint32_t, GroupcastProtectionMode, std::string>>{
                      {maxRtsCtsThreshold, GroupcastProtectionMode::RTS_CTS, "no protection"},
                      {500, GroupcastProtectionMode::RTS_CTS, "RTS-CTS"},
@@ -2267,7 +2267,7 @@
                                                .startGroupcast = groupcastStartTime,
                                                .startUnicast = unicastStartTime,
                                                .rtsThreshold = rtsThreshold,
-                                               .gcrProtectionMode = gcrPotection},
+                                               .gcrProtectionMode = gcrProtection},
                                               {corruptedBars, corruptedBlockAcks}),
                                 useSpectrum ? TestCase::Duration::EXTENSIVE
                                             : TestCase::Duration::QUICK);
@@ -2281,7 +2281,7 @@
                                                    .startGroupcast = groupcastStartTime,
                                                    .startUnicast = unicastStartTime,
                                                    .rtsThreshold = rtsThreshold,
-                                                   .gcrProtectionMode = gcrPotection,
+                                                   .gcrProtectionMode = gcrProtection,
                                                    .mpdusToCorruptPerPsdu = {{1, {{0, {2}}}}}},
                                                   {corruptedBars, corruptedBlockAcks}),
                                     useSpectrum ? TestCase::Duration::EXTENSIVE
@@ -2294,7 +2294,7 @@
                                                    .startGroupcast = groupcastStartTime,
                                                    .startUnicast = unicastStartTime,
                                                    .rtsThreshold = rtsThreshold,
-                                                   .gcrProtectionMode = gcrPotection,
+                                                   .gcrProtectionMode = gcrProtection,
                                                    .mpdusToCorruptPerPsdu = {{1, {{0, {1}}}}}},
                                                   {corruptedBars, corruptedBlockAcks}),
                                     useSpectrum ? TestCase::Duration::EXTENSIVE
@@ -2307,7 +2307,7 @@
                                                    .startGroupcast = groupcastStartTime,
                                                    .startUnicast = unicastStartTime,
                                                    .rtsThreshold = rtsThreshold,
-                                                   .gcrProtectionMode = gcrPotection,
+                                                   .gcrProtectionMode = gcrProtection,
                                                    .mpdusToCorruptPerPsdu = {{1, {{0, {1, 2}}}}}},
                                                   {corruptedBars, corruptedBlockAcks}),
                                     useSpectrum ? TestCase::Duration::EXTENSIVE
@@ -2324,7 +2324,7 @@
                                                .startGroupcast = groupcastStartTime,
                                                .startUnicast = unicastStartTime,
                                                .rtsThreshold = rtsThreshold,
-                                               .gcrProtectionMode = gcrPotection,
+                                               .gcrProtectionMode = gcrProtection,
                                                .mpdusToCorruptPerPsdu = {{1, {{1, {2}}}}}},
                                               {corruptedBars, corruptedBlockAcks}),
                                 useSpectrum ? TestCase::Duration::EXTENSIVE
@@ -2339,7 +2339,7 @@
                                                .startGroupcast = groupcastStartTime,
                                                .startUnicast = unicastStartTime,
                                                .rtsThreshold = rtsThreshold,
-                                               .gcrProtectionMode = gcrPotection,
+                                               .gcrProtectionMode = gcrProtection,
                                                .mpdusToCorruptPerPsdu = {{1, {{1, {1}}}}}},
                                               {corruptedBars, corruptedBlockAcks}),
                                 useSpectrum ? TestCase::Duration::EXTENSIVE
@@ -2355,7 +2355,7 @@
                                      .startGroupcast = groupcastStartTime,
                                      .startUnicast = unicastStartTime,
                                      .rtsThreshold = rtsThreshold,
-                                     .gcrProtectionMode = gcrPotection,
+                                     .gcrProtectionMode = gcrProtection,
                                      .mpdusToCorruptPerPsdu = {{1, {{1, {1}}, {2, {2}}}}}},
                                     {corruptedBars, corruptedBlockAcks}),
                                 useSpectrum ? TestCase::Duration::EXTENSIVE
@@ -2371,7 +2371,7 @@
                                              .startGroupcast = groupcastStartTime,
                                              .startUnicast = unicastStartTime,
                                              .rtsThreshold = rtsThreshold,
-                                             .gcrProtectionMode = gcrPotection,
+                                             .gcrProtectionMode = gcrProtection,
                                              .mpdusToCorruptPerPsdu = {{1, {{1, {2}}, {2, {1}}}}}},
                                             {corruptedBars, corruptedBlockAcks}),
                                         useSpectrum ? TestCase::Duration::EXTENSIVE
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/test/wifi-mac-ofdma-test.cc ns-3.46/src/wifi/test/wifi-mac-ofdma-test.cc
--- ns-3.45/src/wifi/test/wifi-mac-ofdma-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/test/wifi-mac-ofdma-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -2231,7 +2231,7 @@
     {
         // create a listening VHT station
         wifi.SetStandard(WIFI_STANDARD_80211ac);
-        wifi.Install(phy, mac, Create<Node>());
+        wifi.Install(phy, mac, CreateObject<Node>());
     }
 
     wifi.SetStandard(m_scenario == WifiOfdmaScenario::HE ? WIFI_STANDARD_80211ax
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/test/wifi-mac-queue-test.cc ns-3.46/src/wifi/test/wifi-mac-queue-test.cc
--- ns-3.45/src/wifi/test/wifi-mac-queue-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/test/wifi-mac-queue-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -214,8 +214,8 @@
     Enqueue(rxAddr2, false, MilliSeconds(70));
     Enqueue(rxAddr2, false, MilliSeconds(75));
 
-    WifiContainerQueueId queueId1{WIFI_QOSDATA_QUEUE, WIFI_UNICAST, rxAddr1, 0};
-    WifiContainerQueueId queueId2{WIFI_QOSDATA_QUEUE, WIFI_UNICAST, rxAddr2, 0};
+    WifiContainerQueueId queueId1{WIFI_QOSDATA_QUEUE, WifiRcvAddr::UNICAST, rxAddr1, 0};
+    WifiContainerQueueId queueId2{WIFI_QOSDATA_QUEUE, WifiRcvAddr::UNICAST, rxAddr2, 0};
 
     Simulator::Schedule(MilliSeconds(25), [&]() {
         /**
@@ -421,6 +421,97 @@
  * @ingroup wifi-test
  * @ingroup tests
  *
+ * @brief Test that a wifi MAC queue is correctly flushed even if (at least) a container queue
+ * is blocked.
+ */
+class WifiMacQueueFlushTest : public TestCase
+{
+  public:
+    WifiMacQueueFlushTest();
+
+  private:
+    void DoRun() override;
+};
+
+WifiMacQueueFlushTest::WifiMacQueueFlushTest()
+    : TestCase("Test WifiMacQueue Flush operation")
+{
+}
+
+void
+WifiMacQueueFlushTest::DoRun()
+{
+    auto wifiMacQueue = CreateObject<WifiMacQueue>(AC_BE);
+    auto wifiMacScheduler = CreateObject<FcfsWifiQueueScheduler>();
+    wifiMacScheduler->m_perAcInfo[AC_BE].wifiMacQueue = wifiMacQueue;
+    wifiMacQueue->SetScheduler(wifiMacScheduler);
+
+    const auto addr1 = Mac48Address::Allocate();
+    const auto addr2 = Mac48Address::Allocate();
+
+    // Initialize the queue with some packets.
+    const auto tid = wifiAcList.at(AC_BE).GetLowTid();
+    const std::size_t nPackets = 5;
+    for (std::size_t i = 0; i < nPackets; i++)
+    {
+        WifiMacHeader header(WIFI_MAC_QOSDATA);
+        header.SetAddr1(addr1);
+        header.SetAddr2(addr2);
+        header.SetQosTid(tid);
+        auto item = Create<WifiMpdu>(Create<Packet>(), header);
+        wifiMacQueue->Enqueue(item);
+    }
+
+    WifiContainerQueueId queueId(WifiContainerQueueType::WIFI_QOSDATA_QUEUE,
+                                 WifiRcvAddr::UNICAST,
+                                 addr1,
+                                 tid);
+
+    // Check that all elements are inserted successfully.
+    NS_TEST_EXPECT_MSG_EQ(wifiMacQueue->GetNPackets(),
+                          nPackets,
+                          "Queue has unexpected number of elements");
+
+    NS_TEST_EXPECT_MSG_EQ(wifiMacQueue->GetNPackets(queueId),
+                          nPackets,
+                          "Unexpected number of packets in container queue");
+
+    NS_TEST_EXPECT_MSG_EQ(wifiMacScheduler->GetNext(AC_BE, SINGLE_LINK_OP_ID).has_value(),
+                          true,
+                          "Expected the scheduler to return a container queue");
+
+    // block the queue containing the packets
+    wifiMacScheduler->BlockQueues(WifiQueueBlockedReason::TID_NOT_MAPPED,
+                                  AC_BE,
+                                  {WifiContainerQueueType::WIFI_QOSDATA_QUEUE},
+                                  addr1,
+                                  addr2,
+                                  {tid},
+                                  {SINGLE_LINK_OP_ID});
+
+    NS_TEST_EXPECT_MSG_EQ(wifiMacScheduler->GetNext(AC_BE, SINGLE_LINK_OP_ID).has_value(),
+                          false,
+                          "Expected the container queue to  be blocked");
+
+    wifiMacQueue->Flush();
+
+    // Check that all elements are removed successfully.
+    NS_TEST_EXPECT_MSG_EQ(wifiMacQueue->GetNPackets(),
+                          0,
+                          "Queue has unexpected number of elements");
+
+    NS_TEST_EXPECT_MSG_EQ(wifiMacQueue->GetNPackets(queueId),
+                          0,
+                          "Unexpected number of packets in container queue");
+
+    wifiMacQueue->Dispose();
+    Simulator::Destroy();
+}
+
+/**
+ * @ingroup wifi-test
+ * @ingroup tests
+ *
  * @brief Wifi MAC Queue Test Suite
  */
 class WifiMacQueueTestSuite : public TestSuite
@@ -434,6 +525,7 @@
 {
     AddTestCase(new WifiMacQueueDropOldestTest, TestCase::Duration::QUICK);
     AddTestCase(new WifiExtractExpiredMpdusTest, TestCase::Duration::QUICK);
+    AddTestCase(new WifiMacQueueFlushTest, TestCase::Duration::QUICK);
 }
 
 static WifiMacQueueTestSuite g_wifiMacQueueTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/test/wifi-mlo-test.cc ns-3.46/src/wifi/test/wifi-mlo-test.cc
--- ns-3.45/src/wifi/test/wifi-mlo-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/test/wifi-mlo-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -1581,7 +1581,7 @@
             (legacyAssoc
                  ? m_staMacs[0]->GetFrameExchangeManager(m_staSetupLinks.front())->GetAddress()
                  : m_staMacs[0]->GetAddress());
-        WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WIFI_UNICAST, addr, 0);
+        WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WifiRcvAddr::UNICAST, addr, 0);
 
         // the queue on the AP should have a mask if and only if the link has been setup
         auto mask = m_apMac->GetMacQueueScheduler()->GetQueueLinkMask(AC_BE, queueId, linkId);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/test/wifi-non-ht-dup-test.cc ns-3.46/src/wifi/test/wifi-non-ht-dup-test.cc
--- ns-3.45/src/wifi/test/wifi-non-ht-dup-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/test/wifi-non-ht-dup-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -127,7 +127,8 @@
     void SetMuRtsTxVector(const WifiTxVector& muRtsTxVector);
 
   private:
-    Ptr<MuRtsCtsHePhy> m_muRtsCtsHePhy; ///< Pointer to HE PHY instance used for MU-RTS/CTS PHY test
+    std::shared_ptr<MuRtsCtsHePhy>
+        m_muRtsCtsHePhy; ///< Pointer to HE PHY instance used for MU-RTS/CTS PHY test
 
     // end of class MuRtsCtsSpectrumWifiPhy
 };
@@ -144,7 +145,7 @@
     : SpectrumWifiPhy()
 {
     NS_LOG_FUNCTION(this);
-    m_muRtsCtsHePhy = Create<MuRtsCtsHePhy>();
+    m_muRtsCtsHePhy = std::make_shared<MuRtsCtsHePhy>();
     m_muRtsCtsHePhy->SetOwner(this);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/test/wifi-phy-cca-test.cc ns-3.46/src/wifi/test/wifi-phy-cca-test.cc
--- ns-3.45/src/wifi/test/wifi-phy-cca-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/test/wifi-phy-cca-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -140,7 +140,7 @@
      * signal occupies
      * @param expectedCcaThreshold the CCA threshold that is expected to be reported
      */
-    void VerifyCcaThreshold(const Ptr<PhyEntity> phy,
+    void VerifyCcaThreshold(const std::shared_ptr<PhyEntity> phy,
                             const Ptr<const WifiPpdu> ppdu,
                             WifiChannelListType channelType,
                             dBm_u expectedCcaThreshold);
@@ -273,7 +273,7 @@
 }
 
 void
-WifiPhyCcaThresholdsTest::VerifyCcaThreshold(const Ptr<PhyEntity> phy,
+WifiPhyCcaThresholdsTest::VerifyCcaThreshold(const std::shared_ptr<PhyEntity> phy,
                                              const Ptr<const WifiPpdu> ppdu,
                                              WifiChannelListType channelType,
                                              dBm_u expectedCcaThreshold)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/test/wifi-phy-mu-mimo-test.cc ns-3.46/src/wifi/test/wifi-phy-mu-mimo-test.cc
--- ns-3.45/src/wifi/test/wifi-phy-mu-mimo-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/test/wifi-phy-mu-mimo-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -273,7 +273,8 @@
     void DoInitialize() override;
     void DoDispose() override;
 
-    Ptr<MuMimoTestHePhy> m_ofdmTestHePhy; ///< Pointer to HE PHY instance used for MU-MIMO test
+    std::shared_ptr<MuMimoTestHePhy>
+        m_ofdmTestHePhy; ///< Pointer to HE PHY instance used for MU-MIMO test
 
     // end of class MuMimoSpectrumWifiPhy
 };
@@ -289,7 +290,7 @@
 MuMimoSpectrumWifiPhy::MuMimoSpectrumWifiPhy(uint16_t staId)
     : SpectrumWifiPhy()
 {
-    m_ofdmTestHePhy = Create<MuMimoTestHePhy>(staId);
+    m_ofdmTestHePhy = std::make_shared<MuMimoTestHePhy>(staId);
     m_ofdmTestHePhy->SetOwner(this);
 }
 
@@ -1373,7 +1374,7 @@
                                                    txVector,
                                                    m_phyAp->GetPhyBand());
     txVector.SetLength(length);
-    auto hePhyAp = DynamicCast<HePhy>(m_phyAp->GetPhyEntity(WIFI_MOD_CLASS_HE));
+    auto hePhyAp = std::dynamic_pointer_cast<HePhy>(m_phyAp->GetPhyEntity(WIFI_MOD_CLASS_HE));
     hePhyAp->SetTrigVector(txVector, m_expectedPpduDuration);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/test/wifi-phy-ofdma-test.cc ns-3.46/src/wifi/test/wifi-phy-ofdma-test.cc
--- ns-3.45/src/wifi/test/wifi-phy-ofdma-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/test/wifi-phy-ofdma-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -243,11 +243,11 @@
     /**
      * @return a const pointer to the latest PHY entity instance
      */
-    Ptr<LatestPhyEntityType> GetPhyEntity() const;
+    std::shared_ptr<LatestPhyEntityType> GetPhyEntity() const;
 
   private:
     /// Pointer to latest PHY entity instance used for OFDMA test
-    Ptr<OfdmaTestPhy<LatestPhyEntityType>> m_ofdmaTestPhy;
+    std::shared_ptr<OfdmaTestPhy<LatestPhyEntityType>> m_ofdmaTestPhy;
 
     /// Callback providing UID of the PPDU that is about to be transmitted
     TracedCallback<uint64_t> m_phyTxPpduUidTrace;
@@ -276,7 +276,7 @@
 OfdmaSpectrumWifiPhy<LatestPhyEntityType>::OfdmaSpectrumWifiPhy(uint16_t staId)
     : SpectrumWifiPhy()
 {
-    m_ofdmaTestPhy = Create<OfdmaTestPhy<LatestPhyEntityType>>(staId);
+    m_ofdmaTestPhy = std::make_shared<OfdmaTestPhy<LatestPhyEntityType>>(staId);
     m_ofdmaTestPhy->SetOwner(this);
 }
 
@@ -344,10 +344,10 @@
 }
 
 template <typename LatestPhyEntityType>
-Ptr<LatestPhyEntityType>
+std::shared_ptr<LatestPhyEntityType>
 OfdmaSpectrumWifiPhy<LatestPhyEntityType>::GetPhyEntity() const
 {
-    return DynamicCast<LatestPhyEntityType>(m_ofdmaTestPhy /*GetLatestPhyEntity()*/);
+    return std::dynamic_pointer_cast<LatestPhyEntityType>(m_ofdmaTestPhy /*GetLatestPhyEntity()*/);
 }
 
 /**
@@ -2706,7 +2706,7 @@
         HePhy::ConvertHeTbPpduDurationToLSigLength(ppduDuration, txVector, m_phy->GetPhyBand());
     txVector.SetLength(length);
     m_trigVector.SetLength(length);
-    auto hePhy = DynamicCast<HePhy>(m_phy->GetLatestPhyEntity());
+    auto hePhy = std::dynamic_pointer_cast<HePhy>(m_phy->GetLatestPhyEntity());
     hePhy->SetTrigVector(m_trigVector, ppduDuration);
     ppdu->ResetTxVector();
     m_phy->StartRx(rxParams, nullptr);
@@ -4348,7 +4348,8 @@
     const auto detectionDuration = WifiPhy::GetPreambleDetectionDuration();
     const auto txVectorSta1 = GetTxVectorForTbPpdu(1, 1, 0);
     const auto txVectorSta2 = GetTxVectorForTbPpdu(2, 2, 0);
-    const auto phyEntity = DynamicCast<OfdmaTestPhy<LatestPhyEntityType>>(m_phyAp->GetPhyEntity());
+    const auto phyEntity =
+        std::dynamic_pointer_cast<OfdmaTestPhy<LatestPhyEntityType>>(m_phyAp->GetPhyEntity());
     const auto nonOfdmaDuration = phyEntity->CalculateNonHeDurationForHeTb(txVectorSta2);
     NS_ASSERT(nonOfdmaDuration == phyEntity->CalculateNonHeDurationForHeTb(txVectorSta1));
 
@@ -5589,7 +5590,7 @@
     std::tie(length, ppduDuration) =
         HePhy::ConvertHeTbPpduDurationToLSigLength(ppduDuration, trigVector, m_phyAp->GetPhyBand());
     trigVector.SetLength(length);
-    auto hePhyAp = DynamicCast<HePhy>(m_phyAp->GetLatestPhyEntity());
+    auto hePhyAp = std::dynamic_pointer_cast<HePhy>(m_phyAp->GetLatestPhyEntity());
     hePhyAp->SetTrigVector(trigVector, ppduDuration);
 }
 
@@ -5866,7 +5867,7 @@
         {
             NS_ABORT_MSG("Unknown STA-ID (" << staId << ")");
         }
-        ui.SetUlTargetRssi(ulTargetRssi);
+        ui.SetUlTargetRxPower(ulTargetRssi);
 
         CtrlBAckRequestHeader bar;
         bar.SetType(BlockAckReqType::COMPRESSED);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/test/wifi-phy-reception-test.cc ns-3.46/src/wifi/test/wifi-phy-reception-test.cc
--- ns-3.45/src/wifi/test/wifi-phy-reception-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/test/wifi-phy-reception-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -849,7 +849,7 @@
     /**
      * Check the number of received packets
      * @param expectedSuccessCount the number of successfully received packets
-     * @param expectedFailureCount the number of unsuccessfuly received packets
+     * @param expectedFailureCount the number of unsuccessfully received packets
      */
     void CheckRxPacketCount(uint32_t expectedSuccessCount, uint32_t expectedFailureCount);
 };
@@ -4207,7 +4207,7 @@
                    const std::vector<bool>& statusPerMpdu);
 
     /**
-     * Function called upon a PSDU received unsuccessfuly
+     * Function called upon a PSDU received unsuccessfully
      * @param psdu the PSDU
      */
     void RxFailure(Ptr<const WifiPsdu> psdu);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/test/wifi-phy-thresholds-test.cc ns-3.46/src/wifi/test/wifi-phy-thresholds-test.cc
--- ns-3.45/src/wifi/test/wifi-phy-thresholds-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/test/wifi-phy-thresholds-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -101,7 +101,7 @@
 
     Ptr<SpectrumWifiPhy> m_phy;   ///< PHY object
     uint32_t m_rxSuccess;         ///< count number of successfully received packets
-    uint32_t m_rxFailure;         ///< count number of unsuccessfuly received packets
+    uint32_t m_rxFailure;         ///< count number of unsuccessfully received packets
     uint32_t m_rxDropped;         ///< count number of dropped packets
     uint32_t m_stateChanged;      ///< count number of PHY state change
     uint32_t m_rxStateCount;      ///< count number of PHY state change to RX state
